::catch {};#\
@"%prop_dir%\expect-5.21\bin\wish80.exe" %0 % 1 %2
::catch {};#\
@goto eof
#puts "argv0='argv0' argc=$argc argv='$argv' pwd='[pwd]'"
#
# remove this and lines above for use on unix
#!/usr/bin/wish -f
#
###################################################################
###################################################################          
##                                                               ## 
##                Clickfit_m  - FITFUN GUI                       ##
##                                                               ##
##                  Ron Ghosh,   2006-13                         ##
##                                                               ##
###################################################################
#
# Fitfun_m allows appending sets of data, and calculation uses separate
# (or shared) parameters to fit the whole assembly
#
# Differences			Clickfit		Clickfit_m
#
#				treats sequences	treats sets
#
# proc setmemo			memo.mff		memom.mff
# proc rintreat						append new data
# proc iniget	last .fcl	$HOME/ffn.ffn		$HOME/ffn.ffm
#				seq read/increment	absent
#		reads		memo.mff		memom.mff
# proc vcmd			reads value,step	reads value,step,set
# proc viewset			absent			shows current set info
# add_data			mcmd			absent
#				add_data
#				removeall
#				addall
#				showin
#				fitsq
# MAIN
# configuration file		$HOME/ffn.conf		$HOME/ffm.conf
# menu/view/set			absent
# Buttons 			fitseq			clear sets/show set
# 	
#
# Complete list of Globals (main)
global acc hhh o1 o2 o3 o4 o5 o6 
global m1 m2 m3 m4
global xdatamin xdatamax xplmin xplmax ydatamin ydatamax yplmin yplmax
global npars pgdir cfont atend
global cmdout debug calc_timeout
global cmdfil repfil logfil inffil itrfil pnam sseq cseq jnam pstn
global lll eent llab inmsg retinp ininp infrm npointin nfit
global r1 r2 r3 r4 r5 r6 r7 r8 r9 r10 r11 r12 r13 r14 repl
global exenam preinfo jinfo readinfo plfinfo precall setlis butlis
global inum vv vo vs pnam cursor psfil vufil frep frsta inset curset
global revsort filscan filsel filin filscan conf fitonce
global curset fseqfil fseqout filscan niter fmod stit
global nrparf nrpar conffile mode lastf lastanc env defdir
global vdate hfile usejcmd numfit title1 pform itrstate

## inframe generic window for getting and partially verifying user data
##
## input is a list for each input, type of filer/filew/var/text
# title line is textxt (may include \n ...)
# then ininp is a list of line-lists
# linelist:
# "label for input"
# type "filer" existing file for read
#      "filew" output file (requires valid directory, no overwrite check)
#      "filep" result is an existing file path
#      "filed" uses default directory if none is given
#      "float" valid float (between min and max if min<max)
#      "text"  line of text
# min   minimum value of float if min<max
# max   maximum value of float if min<max
#
# returns are in globals r1, r2 etc, also string retinp built in check
# retinp includes text as quoted fields allowing easy reads
# note filenames with spaces within should be either avoided or treated as text
# but the the names are not checked
# example usage:
# global infrm inmsg r1 
#set sm "Principal step size "
#set st "Variables are initially stepped by the product of this and the variable step"
#set sp [list "Step" "float" $hhh "0.005" "0.1"]
#set infrm [list $sm $st [list $sp] $hfil]
# hfil is the name of a help file which will have a button to itself
# if absent then no button is created - backward compatible
#inframe
#if {$inmsg == "OK" } { etc etc...
# result in $retinp (quoted) and $r1 ...$r2 etc
# Ron Ghosh, ILL, May 2006
proc inframe { } {
global lll eent llab inmsg retinp ininp infrm defdir hfile
global r1 r2 r3 r4 r5 r6 r7 r8 r9 r10 r11 r12 r13 r14
set naminp [lindex $infrm 0]
set intxt [lindex $infrm 1]
set ininp [lindex $infrm 2]
set hfile [lindex $infrm 3]
set lininp $ininp
toplevel .nam -width 400
#focus .nam
raise .nam
grab set .nam
wm title .nam $naminp
label .nam.head -text $intxt
#  need to set box width!!!!!
pack .nam.head -side top -ipadx 80
set kk [llength $ininp]
set jj 0
foreach inlin $ininp {
  incr jj 
## ininput boxes set up
  set lin lin$jj
  set lll $lin
  frame .nam.$lin
  set desc [lindex $inlin 0]
  set typb [lindex $inlin 1]
  set bval [lindex $inlin 2]
  set llab "$lin.lab"
  set eent "$lin.ent"
  set rr "r$jj"
  set $rr $bval
    if { $typb == "float" } {
    set minv [lindex $inlin 3]
    set maxv [lindex $inlin 4]
    if { $maxv > $minv } {
    set desc "$desc (between $minv and $maxv)"
    } }
  label  .nam.$llab -text $desc -justify left
  entry .nam.$eent -text $bval -width 40
 .nam.$eent configure  -textvariable $rr
  pack .nam.$llab -side left -padx  5  -pady 5 
 pack .nam.$eent -side right -padx 5 -pady 5
 pack .nam.$lin -fill x
}
if { $kk == 1 } {
bind .nam.lin1.ent <Return> {
check
if { $inmsg == "" } {
set inmsg "OK"
destroy .nam
} else {
  .nam.comm configure -text $inmsg -fg red
  .nam configure -width 300
}}}
label .nam.comm -text ""
#"this is a comment line (global)"
pack .nam.comm -side bottom -fill x
button .nam.quit -text "Dismiss" -command {
  set inmsg "Dismiss"
  destroy .nam
  }
button .nam.apll -text "Accept" -command {
check  
if { $inmsg == "" } {
#no errors and all return values have been set
set inmsg OK
destroy .nam
} else {
  .nam.comm configure -text $inmsg -fg red
  .nam configure -width 300
  }
}
#end of command Accept
pack .nam.quit -side left 
pack .nam.apll -side right 
# create help button...if appropriate
if { $hfile == "" } {
} else {
#look for help file - if found make button
if { [file dirname $hfile ] == "." }  {set hfile $defdir/$hfile }
if { [file exists $hfile ] } {
button .nam.help -text Help -command {
set vufil $hfile
viewfile
} 
pack .nam.help
} } 
tkwait window .nam
}


proc check { } {
global ininp inmsg retinp defdir
# each type of field float or file must be checked
  set inmsg ""
  set jj 0
  set retinp ""
  foreach inlin $ininp {
  incr jj 
  if { $inmsg == "" } {
  set lin .nam.lin$jj
  set desc [lindex $inlin 0]
  set typb [lindex $inlin 1]
  set bval [lindex $inlin 2]
  set eent "$lin.ent"
  set retg [$eent get ]
# build up output string space separated with text/files in quotes 
  if { $typb != "float" } {
  set retinp "$retinp\"$retg\" "
     } else {
  set retinp "$retinp $retg "
  }       

  if { $typb == "filer" } {
     if { ! [file  exists $retg ]     } {
     set inmsg " $desc : file \" $retg \" not found "}
     }

  if { $typb == "filed" } {
 #  look for preceding directory, else add defdir to name
   set rretg $retg
   if { [ file dirname $retg ] == "." } { set rretg $defdir/$retg }
     if { ! [file  exists $rretg ]     } {
     set inmsg " $desc : file \" $rretg \" not found "}
     }

  if { $typb == "filew" } {
     set ff [file dirname $retg ]
     if { ! [file  isdirectory $ff ]     } {
     set inmsg " $desc : directory \" $ff \" not found "}
     if { [file exists $retg ] } {
     set inmsg " $desc : file $retg already exists " }
     }
  
   if { $typb == "filep" } {
     if { ! [file  isdirectory $retg ]     } {
     set inmsg " $desc : directory \" $retg \" not found "}
     }

  if { $typb == "float" } {
 # check proper number with expr
   set real [catch {expr $retg} ] 
    if { $real == 0 } {
     set minv [lindex $inlin 3]
     set maxv [lindex $inlin 4]
      if { ($maxv > $minv ) &&  ( $retg < $minv ) } {
       set inmsg "Value $desc $retg less than $minv " }
      if { ($maxv > $minv) && ( $retg > $maxv ) } {
       set inmsg " $desc $retg greater than $maxv " }
   } else {
      set inmsg "$desc $retg is not a number"
  } } } 
#here is end of inmsg check at top-test limiting foreach-es treated fully 
}
#dblocate $retinp
}


######################  dblocate     debug window

proc dblocate  W {
toplevel .dbl
frame .dbl.f
label .dbl.f.label -text " ... $W ..." -fg red
button .dbl.f.but -text "OK" -command {destroy .dbl }
pack .dbl.f.label  .dbl.f.but
pack .dbl.f
focus .dbl
grab set .dbl
tkwait window .dbl
}

##################### updatinfo  reads fif file and updates paras and listbox
proc updatinfo  {} {
global acc hhh o1 o2 o3 o4 o5 o6 
global xdatamin xdatamax xplmin xplmax ydatamin ydatamax yplmin yplmax
global npars inffil
set npars 0
#  read fif file...

if [ catch {open $inffil r } inf ] { 
      set err " fif file error "
       dblocate  $err
   } else {

set nline 0
#set inf [open $infl]
gets $inf parms
# first line is program id and date
gets $inf parms
# second line is return message
.main.tt configure -text $parms
# third line is spare
gets $inf parms
gets $inf parms
scan $parms {%g%g} hhh acc
gets $inf parms
scan $parms {%g%g} o1 o2
gets $inf parms
scan $parms {%g%g} o3 o4
gets $inf parms
scan $parms {%g%g} o5 o6
gets $inf parms
scan $parms {%g%g%g%g} xdatamin xdatamax xplmin xplmax 
gets $inf  parms
scan $parms {%g%g%g%g} ydatamin ydatamax yplmin yplmax 
.main.middle.lb delete 0 end
.main.middle.lb insert end "                    new value   old value     step     % deviation"
while { [gets $inf parms ] >= 0 } {
    .main.middle.lb insert end  $parms
    incr npars
  }
close $inf
}
}

##################### mancmd  permits all manual commands (may not all work if need input)

proc mancmd  {} {
global cmdout cfont
toplevel .man
frame .man.f 
label .man.f.label -width 70 -text "
 Basic fitting and control commands
 H              type this list
 R input text   read new data - input text used by read routine
 D              display data
 X min max      change current x-scale to min<x<max
                if min and max are 0, show current limits
 Y min max      change current y-scale to min<y<max  etc.
 V n v s        change parameter number n to v
                with associated step s (about 1.0) if
                this is to be fitted.
                if s is negative parameter n is tied
                to preceding parameter #-s
 V              (no parameters) list current values
 I s1 s2        image copy of parameters from set1 to set2
 F n (N)        fit n iterations (0 to show current curve)
                N (optional) for no plot while fitting
 G n1 s n2 (s1 s2..  Groups stepping n1 to n2 in sets s1..
                (all sets if s1=0) removes links if n2 is 0
 O a b c d e f  (s) only fit spectrum between range of a<x<b
                and c<x<d etc. (ignored if both are zero)
		if s1 is non-zero only data set s is limited
 P              plot fit and data on hardcopy
 W flnme        write fit and data onto output file flname.fpl
 L (F)          list last fit (F for full listing)
 S              save current parameters
 C              enable/disable cursor(in next plot)
 Z              time stamp, clear screen
 T extra text   set manual title for graphs
 J input text   jump to special routine
 E              EXIT from program.
 Command R,D,X,Y,V,I,G,F,O,P,L,W,C,J,S,T 
" -font $cfont -justify left
entry .man.f.ent  -textvariable cmdout 
button .man.f.exe -text "Send command and dismiss window" -command {
sendcmd
if { $cmdout == "e" } { exit }
if { $cmdout == "E" } {exit }
destroy .man
}

button .man.f.but -text "Dismiss" -command {destroy .man }
bind .man.f.ent <Return> {
sendcmd
if { ($cmdout== "e" ) || ($cmdout == "E" ) } { exit }
set cmdout ""
}
pack .man.f.label  -side top
pack .man.f.exe .man.f.ent -side bottom
pack .man.f
focus .man
grab set .man
}

####################  debpro   uses inframe to set debug status for comms
proc debpro  {} {
global debug infrm inmsg
set dwtle "Debug setting"
set dd $debug
if { $dd == 0 } { set dtitle "Set debug on ?"}
if { $dd == 1 } { set dtitle "Set debug off?"}
set infrm [list $dwtle $dtitle ]
inframe
if { $inmsg == "OK" } {
if { $dd == 0 } { 
toplevel .d
label  .d.debug1 -text "this is a dummy db1"
pack .d.debug1 -side top -fill x
label  .d.debug2 -text "this is a dummy db2"
pack .d.debug2 -side top -fill x
set debug 1
}
if { $dd == 1 } {
set debug 0
destroy .d }
}
}
###################  curpro  sets up cursor status for next display command
proc curpro  {} {
global cursor cmdout infrm inmsg
set cwtle "Cursor setting"
set cc $cursor
if { $cc == 0 } { 
 set ctitle "Set cursor on in next plot DISPLAY ? \n \
\n In Graphics window: mouse/left click for x,y; <return> to end"
.main.tt configure -text "In Graphics window: mouse/left click for x,y; <return> to end" -fg blue
}
if { $cc == 1 } { set ctitle "Set cursor off?"}
set infrm [list $cwtle $ctitle ]
inframe
if { $inmsg == "OK" } {
if { $cc == 0 } { 
set cursor 1
}
if { $cc == 1 } {
set cursor 0 }
set cmdout "C"
sendcmd
}
}
###################  viewlog  starts file viewer
proc viewlog {} {
global vufil logfil atend
set atend 0
set vufil $logfil
viewfile
set atend 1
}
################### viewfile  starts generic file viewer
proc viewfile {} {
global vufil cfont atend
toplevel .lg
grab set .lg
focus .lg
listbox .lg.lb -width 80 -height 30 -font $cfont -yscrollcommand ".lg.scroll set " -background white
scrollbar .lg.scroll -command " .lg.lb yview "
wm title .lg $vufil
if { [catch {open $vufil r } inf ] == 0  } {
while { [gets $inf line ] >= 0 } {
.lg.lb insert end $line
}
close $inf
######### view logfile from end
if { $atend == 0 } {.lg.lb yview end }
}

button .lg.but -text "Dismiss" -command { destroy .lg}
pack  .lg.lb -side left -fill y
pack .lg.scroll -side right -fill y
pack .lg.but -side bottom
tkwait window .lg
}

##################  cammand "Only" slects regions for fit 
proc only {} {
global xdatamin xdatamax infrm inmsg cmdout
global r1 r2 r3 r4 r5 r6 r7 o1 o2 o3 o4 o5 o6

set nnset 0
set owtl "Limit fit regions"
set ottl "Fitting may be restricted in up to three x - regions \n\n \
data run from $xdatamin to $xdatamax \n\n \
set all to 0  to use full range \n
set set number to zero to apply to all sets of data"

set ov1 [list  "First x region - low limit" "float" $o1 " " " "]
set ov2 [list  "   high limit" "float" $o2 " " " "]
set ov3 [list  "Second x region - low limit" "float" $o3 " " " "]
set ov4 [list  "   high limit" "float" $o4 " " " "]
set ov5 [list  "Third x region - low limit" "float" $o5 " " " "]
set ov6 [list  "   high limit" "float" $o6 " " " "]
set olst [list $ov1 $ov2 $ov3 $ov4 $ov5 $ov6 ]
set pr7 [list  "Apply limits to set number (or 0 for all)" "float" $nnset "0" "20" ]
set olst [list $ov1 $ov2 $ov3 $ov4 $ov5 $ov6 $pr7]
set infrm [list $owtl $ottl $olst ]
inframe
if { $inmsg == "OK" } {
set nnset $r7
set cmdout "O  $r1 $r2 $r3 $r4 $r5 $r6 $nnset"
sendcmd
}}
#################  command to set x,y scale limits
proc scales {} {
global xdatamin xdatamax ydatamin ydatamax xplmin xplmax yplmin yplmax
global infrm inmsg cmdout
global r1 r2 r3 r4 r5 r6 

set pwtl "Set plotting scales"
set pttl "x - data run from $xdatamin to $xdatamax \n
y - data run from $ydatamin $ydatamax "
set pv1 [list  "X values - low limit" "float" $xplmin " " " "]
set pv2 [list  "   high limit" "float" $xplmax " " " "]
set pv3 [list  "Y values - low limit" "float" $yplmin " " " "]
set pv4 [list  "   high limit" "float" $yplmax " " " "]
set plst [list $pv1 $pv2 $pv3 $pv4 ]
set infrm [list $pwtl $pttl $plst ]
inframe
if { $inmsg == "OK" } {
set cmdout "x  $r1 $r2  "
sendcmd
set cmdout "y $r3 $r4 "
sendcmd
}}
####################  sets principal step size
proc steps {} {
global infrm inmsg cmdout hhh r1 
set sm "Principal step size "
set st "Variables are initially stepped by the product of this and the variable step"
set sp [list "Step" "float" $hhh "0.005" "0.1"]
set infrm [list $sm $st [list $sp]]
inframe
if {$inmsg == "OK" } {
set cmdout "v 300 $r1" 
sendcmd
}}
#################### P command plots PostScript
proc curplo {} {
global infrm inmsg cmdout pnam sseq psfil
set pm "PostScript Plot "
set pt "Graph of current fit will be appended to hardcopy graphics 
 (filename for PostScript $psfil)"
set pp [list ]
set infrm [list $pm $pt ]
inframe
set cmdout "P" 
sendcmd
}
################## T command - adds title to graph 
proc addttl {} {
global infrm inmsg cmdout r1
set ptm "Add plot title "
set ptt "Add title line to new plots"
set ptp [list "New text" "text" "Picture title" ]
set infrm [list $ptm $ptt [list $ptp ]]
inframe
if {$inmsg == "OK" } {
set cmdout "T $r1" 
sendcmd
}}
################# J command  - special command
proc specmd {} {
global infrm inmsg cmdout jinfo  retinp
# only get a one line command to start with easier...
set inp [lindex $jinfo 2]
set r1 "" 
set infrm $jinfo
inframe
if {$inmsg == "OK" } {
set cmdout "J  $retinp " 
sendcmd
}}
################# F command - fit
proc fcmd {} {
global nfit nrpar nrparf fitonce cmdout usejcmd numfit
# set title showing fitting has started
.main.tt configure -text " Fitting ..."
# enable interrupt
.cmd.b.inter configure -state normal
# enable fit file write and Jcmd
.main.middle.setbuts.fileit configure -state normal
if { $usejcmd == 1} {
.main.middle.setbuts.postfit configure -state normal }
set cmdout "F $nfit"
# enable seq of fits
if { $nfit > 0 } {
incr numfit
set fitonce 1
if { $nrpar == 1 && $nrparf == 1 } {
.main.middle.setbuts.mseq configure -state normal
} else {
.main.middle.setbuts.desc configure -state normal 
}}
sendcmd
}
################ INTERRUPT fit
proc stopfit {} {
global itrfil itrstate
.cmd.b.inter configure -state disabled
set itr [ open $itrfil w ]
puts   $itr "  Interrupt fit " 
close $itr
set itrstate inter
}
################ W command write out fit
proc wffile { } {
global plfinfo pnam sseq numfit infrm inmsg r1 cmdout
set tseq $sseq
incr tseq -1
set tmp [ format "%03d" $tseq ] 
##### corresponds to log file number
set plw "Fit file Output"
set plt "Write ASCII file with fit and plotting data"
set defffnam "$pnam$tmp\_$numfit.mfl"
set deffftxt "Give filename eg $defffnam "
set plfv [list  $deffftxt "filew" $defffnam ]
set plfinfo [list $plw $plt [list $plfv]]
set infrm $plfinfo
inframe
if { $inmsg == "OK" }  {
set cmdout "w $r1"
sendcmd }
}

################ memo command
proc mmemo { cmd } {
global inmsg cmdout m1 m2 m3 m4
set cmdout $cmd
.main.tt configure -text "'$cmd'"
sendcmd
}

proc setmemo {} {
global m1 m2 m3 m4 r1 r2 r3 r4 infrm inmsg env
set wmm "Setting Memos"
set wtt "Setup useful command lines here"
set mm1 [list "m1" "text" $m1 ] 
set mm2 [list "m2" "text" $m2 ] 
set mm3 [list "m3" "text" $m3 ] 
set mm4 [list "m4" "text" $m4 ] 

set infrm [list $wmm $wtt [list $mm1 $mm2 $mm3 $mm4]]
inframe
if {$inmsg == "OK"} {
set mlist [list $r1 $r2 $r3 $r4 ]
#### check for valid commands R,D,X,Y,V,F,O,P,L,W,C,J,S,T
set cmdlist [list R D X Y V F O P L W C J S T " " ]
set memok 0

foreach mem $mlist {
set mlen [string length $mem]
if {  $mlen > 0 } {
set cmdin 0
foreach let $cmdlist {
set mlet [string range $mem 0 0]
set mlet [string toupper $mlet  ]
if { $mlet == $let   }  {
set cmdin 1 }
}
if { $cmdin == 0 } {
set memok 1
.main.tt configure -text "Memo - invalid command '$mem' : no memo set"
}}}

if { $memok == 0 } {
destroy .mb.memo
menubutton .mb.memo -text "Memo" -menu .mb.memo.menu
menu .mb.memo.menu -tearoff false
### set up and store memos
set ff [ open "$env(HOME)/memom.mff"  w ]
puts $ff $r1
puts $ff $r2
puts $ff $r3
puts $ff $r4
close $ff
set m1 $r1
set m2 $r2
set m3 $r3
set m4 $r4
.mb.memo.menu add command -label "m1: $m1" -command {mmemo $m1} 
.mb.memo.menu add command -label "m2: $m2" -command {mmemo $m2} 
.mb.memo.menu add command -label "m3: $m3" -command {mmemo $m3} 
.mb.memo.menu add command -label "m4: $m4" -command {mmemo $m4} 

.mb.memo.menu add command -label "Set memo" -command {setmemo}
pack .mb.memo -side left

}}
}
##################   sendcmd  writes/reads communications with fitfun program
proc sendcmd {} {
global cmdout debug npointin frep repl calc_timeout
global cmdfil repfil inffil logfil pnam cseq exenam inffil itrstate
set timeup 100
#### allow 10 seconds for most commands
set cmdlet [string range $cmdout 0 0 ]
set cmdlet [string toupper $cmdlet ]
if { $cmdlet == "M" } { set timeup $calc_timeout}
if { $cmdlet == "F" } { set timeup $calc_timeout}
if { $cmdlet == "D" } { set timeup $calc_timeout}
set cf [ open $cmdfil w ]
incr cseq
if { $cseq > 999 } { set cseq 2 }
# command 1 is to send prelude info only
set tmp $cseq
if { $cseq < 100 } { set tmp " $cseq" }
if { $cseq < 10 } { set tmp "  $cseq" }
puts $cf "$tmp:$cmdout\n"
close $cf
if { $cmdlet =="R"} {
set  npointin 0 
.cmd.b.disp configure -state disabled
.cmd.b.try configure -state disabled
.cmd.b.fits configure -state disabled
.cmd.b.do configure -state disabled
.mb.graphics configure -state disabled
.main.middle.setbuts.fileit configure -state disabled
.main.middle.setbuts.postfit configure -state disabled
update 
# disable fits etc
}
if { $cmdlet == "E" } { exit }
###### fitfuns will terminate itself...
###### now await reply
set ticks 0
if { $debug == 1 } { .d.debug1 configure -text "awaiting reply"  }
while { $ticks < $timeup } {
  incr ticks
  set tticks $ticks
if {$debug == 1} {
.d.debug2 configure -text " check for reply after $ticks tcks" 
update
}
  after 100 set itrstate none
  vwait itrstate
#### to ensure stop fit action is running
  update idletasks
#### look for reply file - always there - except if fitfun fails to start
  if  { [ catch { open $repfil r  }  inr ] == 0 } { 
#### file found - read and update if ccseq = cseq
if { $debug == 1 } {.d.debug1 configure -text " reading after $ticks tcks" }
  gets $inr repl
  close $inr
if {$debug ==1 } {.d.debug2 configure -text "ttt $repl ttt" }
  set rrep [split $repl |]  
  set ccseq [ lindex $rrep 0 ]
  set frep [ lindex $rrep 1 ]
  if { $ccseq >= $cseq } { 
  set ticks 11111 
  ###### set comment to reply

  if { $cmdlet =="R"} {
  rintreat
  }

  updatinfo
  }
 
set rr [ lindex $rrep 1 ]
set ll [llength $repl ]
if { $debug == 1 } {
.d.debug1 configure -text " After $tticks ticks"
.d.debug2 configure -text  "replied:  $repl"
}

}}

if { $tticks == $timeup } {
set cmdout "E"
set cf [ open $cmdfil w ]
incr cseq
if { $cseq > 999 } { set cseq 2 }
# command 1 is to send prelude info only
set tmp $cseq
if { $cseq < 100 } { set tmp " $cseq" }
if { $cseq < 10 } { set tmp "  $cseq" }
puts $cf "$tmp:$cmdout\n"
close $cf
set endit1 " No response from $exenam ; see logfile  $logfil"
set endit2 " Last parameter values are in $inffil "
dblocate " $endit1 \n $endit2 "
exit
}
 
}

proc rintreat {} {
global repl setlis curset inset butlis npointin
  set  npointin [string range $repl 4 9 ]  
  if { [expr $npointin] > 0 } {
update
   .cmd.b.disp configure -state normal
   .cmd.b.try configure -state normal
   .cmd.b.fits configure -state normal
   .cmd.b.do configure -state normal
   .mb.graphics configure -state normal
   incr inset
   set stitl [string range $repl 21 40]
   lappend setlis " $npointin data  $stitl"
##  fresh data   
   if { $inset == 1} {
   set  $curset 1
   set ttl [lrange $setlis 0 0]
    set tttl "Set $curset  - $ttl"
   .main.middle.setlabel configure -text $tttl 
   }
  }
}

proc psetsho { } {
global curset inset cmdout setlis 
set ccurset 0
if { $curset > 0 && $curset <= 10 } { set ccurset $curset }
if { $ccurset == 0 } {
  dblocate " invalid set number (integer) $curset " 
  return } 
if { $inset == 0 } {
  dblocate " no sets of data have yet been read in "
  return }
if { $curset > $inset } {
  dblocate " Only $inset sets of data are in use "
  return }
set cmdout "A $curset "
sendcmd
set ind $curset
incr ind -1
set ttl [lrange $setlis $ind $ind]
set tttl "Set $curset  - $ttl"
.main.middle.setlabel configure -text $tttl 
}

#################### iniseq - gets sequence number, starts fitfun prgram with job number 
proc iniseq  {} {
global cmdfil repfil inffil logfil exenam pnam cseq jnam debug sseq psfil
global seq pstn cmdout pgdir npointin env itrfil
set npointin 0
#  read sequ.seq file...

set fname sequ.seq
if [ catch {open $fname r } ins ] {
       set seq 0
   } else {
gets $ins seq
close $ins

}
if { [ catch { expr $seq } ] == 0 } {
incr seq 
} else {
set seq 1 }
# when starting in a new directory 
if { $seq > 999 } {
set seq 1
}
set ins [ open $fname w ]
set sp1 " "
set sp2 "  "
set  tmp $seq
# slight problems to match Fortran I5 formats!
if { $seq < 100 } { set tmp " $seq" }
if { $seq <10 } { set tmp "  $seq" }
puts   $ins "  $tmp\n" 
close $ins
set tmp [format  "%03d" $seq ]
set  cmdfil "$pnam$tmp.fcd"
set repfil "$pnam$tmp.frp"
set inffil "$pnam$tmp.fif"
set logfil "$pnam$tmp.log"
set itrfil "$pnam$tmp.itr"
set jnam "job$tmp"
# for possible psfile output..
set sseq $seq
incr sseq
if { $sseq > 999 } { set sseq 1 }
set tmp [ format "%03d" $sseq ]
set psfil "$pnam$tmp.ps"
.main.tt configure -text " Welcome to Fitfun running $exenam" -fg blue
# command sequence number
set cseq 0
### start program
# BEWARE env must be a global here
set env(PGPLOT_DIR) $pgdir
set gggg [exec  $exenam $jnam  &]
}

#################  iniget - reads .fcl command file
proc iniget {} {
# look for last fcl filename inn $HOME/ffn.ffm
#set current [pwd]
# most globals are initialised here..
global lll eent llab inmsg retinp infrm precall atend
global r1 r2 r3 r4 r5 r6 m1 m2 m3 m4
global env pgdir pstn frsta inset curset setlis
global exenam pnam jinfo preinfo readinfo version hinfo plfinfo
global revsort filscan nrparf nrpar fitonce nfit oldfcl defdir
global vdate usejcmd numfit title1 pform
# from config file
# overwrite these defaults for prefix jcmd rcmd hcmd
# at present only prelude rcmd and jcmd have distict help possible... 
# others - but general help is in menu for rcmd and jcmd easy to add
set jinfo [list "special" "Special function"]
set preinfo [list "Prefix" "Prefix input"]
set readinfo [list "Read data" "Control data read"]
set prewntle "Prefix"
set pretitle "Prefix input"
set prepar [list ]
set preinfo [list $prewntle $pretitle $prepar]
set phelp ""
set jwntle "special"
set jtitle "Special function"
set jinfo [list $jwntle $jtitle ]
set jpar [list]
set jhelp ""
set rwntle "read data"
set rtitle "Control data read"
set rpar [list ]
set readinfo [list $rwntle $rtitle  $rpar]
set rhelp ""
set hwntle "About...(Clickfit version $vdate )"
set htitle "about this program..."
set hpar [list ]
set hinfo [list $hwntle $htitle $hpar]
set version 1.1
set m1 ""
set m2 ""
set m3 ""
set m4 ""
set frsta 0
set inset 0
set curset 1
set setlis ""
set atend 1
set revsort 0
set filscan "*.*"
set nrparf 0
set nrpar 0
set numfit 0
set fitonce 0
set nfit 20
set usejcmd 0
set title1 "Clickfit version $vdate"
############# parse fcl file.... for each line....#####################
set ff [ open $oldfcl r ]
while { [gets  $ff line ]>= 0 } {
set bb [split $line | ]
set bblen [llength $bb]
incr bblen -1
set tp [lindex $bb 0]
set pp [lindex $bb 1]
set vvv [lindex $bb 1]
if { ($tp == "vers" ) && ($vvv > $version )} {
set errs "File version in fcl file doesn't match this version $version"
dblocate $errs
exit
} 
###  main window
if { $tp == "main" } {
if { $pp == "wntle" } {
set title1 [ lindex $bb 2 ]
}
}
###  exe prog...
if { $tp == "prog" } {
set exenam [lindex $bb 1]
fullexe
if { $exenam == "" } exit
}
###  prompt name.
if { ($tp == "prpt" ) } {
set pnam [lindex $bb 1]
}
### restart function
if { ($tp == "rsta") } {
set frsta 1
}
### R command info from .fcl
if {$tp == "rcmd"} {
set done 0
if { $pp =="wntle"} { 
set rwntle [lindex $bb 2] 
}
if {$pp =="title"} {
set rtitle  [lindex $bb 2] 
}
if {$pp =="help" } {
set rhelp [lindex $bb 2]
}
if { ($pp != "title" ) && ($pp != "wntle") && ($pp !="help" ) } {
  set rrr [lrange $bb 1 $bblen ]
  lappend rpar $rrr
}}
### prelude info from .fcl
if { $tp == "prld"} {
set done 0
set pp [lindex $bb 1]
if { $pp =="wntle"} { 
set prewntle [lindex $bb 2] 
}
if {$pp =="title"} {
set pretitle [lindex $bb 2] 
}
if {$pp =="help"} {
set phelp [lindex $bb 2] 
}
if { ($pp != "title" ) && ($pp != "wntle") && ($pp != "help") } {
  set ppp [lrange $bb 1 $bblen]
  lappend prepar  $ppp
}}
### J command info from .fcl
if { $tp == "jcmd"} {
set done 0
set usejcmd 1
if { $pp =="wntle"} { 
set jwntle [lindex $bb 2]
}
if {$pp =="title"} {
set jtitle [lindex $bb 2 ]
}
if {$pp =="help"} {
set jhelp [lindex $bb 2 ]
}
if { ($pp != "title" ) && ($pp != "wntle") && ($pp != "help") } {
  set jjj [lrange $bb 1 $bblen] 
  lappend jpar $jjj
}}
### help command info from .fcl
if { $tp == "hcmd"} {
set done 0
if { $pp =="wntle"} { 
set hwntle [lindex $bb 2]
set hwntle "$hwntle (Clickfit $vdate)"
}
if {$pp =="title"} {
set htitle [lindex $bb 2] 
}
if { ($pp != "title" ) && ($pp != "wntle") } {
  set hhh [lrange $bb 1 $bblen]
  lappend hpar $hhh 
}}

}
### end of parsing of .fcl file ###############################
close $ff
set precall [llength $prepar ]
set readinfo [list $rwntle $rtitle $rpar $rhelp]
set hinfo [list $hwntle $htitle $hpar ]
set preinfo [list $prewntle $pretitle $prepar $phelp]
set jinfo [list $jwntle $jtitle $jpar $jhelp]
# get in oldmemo information
set memofil "$env(HOME)/memom.mff"
if {[file exists $memofil ] } {
set ff [open $memofil r]
gets $ff m1
gets $ff m2
gets $ff m3
gets $ff m4
close $ff
}
}
####end iniget

##################   vcmd - V command sets para ########
proc vcmd { } {
global cmdout infrm inmsg r1 r2 r3 curset
 set parno [.main.middle.lb get active ] 
# set nchar [string bytelength $parno]

 #set inum 1
 set pnnum [string range $parno 0 5 ]
# avoid title line 
 if { $pnnum != "      " } { 

 # scan $pnnum {%d} $inum
 set vnam [string range $parno 0 16]
 set vv [string range $parno 18 29 ]
 set vs [string range $parno 42 53 ]
# scan $pval "\%g\%g\%g" vv vo vs
 set vset [list "Set $vnam " "Give new value and step or link step to another parameter"]
 set vinp1 [list "Value" "float" $vv 0 0 ]
 set vinp2 [list "Step (or link # if negative  see help)" "float" $vs 0 0 ]
 set ifset [string range $vnam 6 6 ]
 if { $ifset != "S" } {
   set vvin [list $vinp1 $vinp2 ] 
   lappend vset $vvin
   set infrm $vset
   inframe
   if { $inmsg == "OK" } {
   set cmdout "v $pnnum $r1 $r2 "
   sendcmd
 }} else {
   set vinp3 [list "Give set numbers to modify, or blank for all" "text" $curset]
   set vvin [list $vinp1 $vinp2 $vinp3 ]
   lappend vset $vvin
   set infrm $vset
   inframe
   if { $inmsg == "OK" } {
   set cmdout "v $pnnum $r1 $r2 $r3 "
   sendcmd
   }   
 }}}
##################   ggcmd - G command sets links from R-Click ########
proc ggcmd { } {
global cmdout infrm inmsg r1 r2 r3 curset npars
 set parno [.main.middle.lb get active ] 
 set pnnum [string range $parno 0 5 ]
# avoid title line 
 if { $pnnum != "      " } { 

 # scan $pnnum {%d} $inum
 set gnam [string range $parno 6 16]
 set gv [string range $parno 18 29 ]
 set gs [string range $parno 42 53 ]
 set gp 1
 set gss 0
# scan $pval "\%g\%g\%g" vv vo vs
 set gset [list "Link steps to $gnam " "Step another parameter with $gnam"]
 set ginp1 [list "Step for $gnam" "float" $gs 0 0 ]
 set ginp2 [list "Give Parameter_2 to vary with $gnam\n or 0 to remove links\n" "float" $gp 0  $npars ]
 set ginp3 [list "Select set numbers (max 6 sets) or 0 for all " $gss 0 ]
 set ggin [list $ginp1 $ginp2 ]
 lappend gset $ggin
 set infrm $gset
 inframe
 if { $inmsg == "OK" } {
 set cmdout "g $pnnum $r1 $r2 $r3 "
 sendcmd
 }
}}
##################   gcmd - G parameter menu command sets links ########
proc gcmd { } {
global cmdout infrm inmsg r1 r2 r3 r4 npars
 set gg 1
 set gs 1
 set gp 2
 set gss 0
 set gset [list "Linking stepping of parameters" "Step Parameter_2 with same step as Parameter_1 "]
 set ginp1 [list "Parameter_1 number" "float" $gg 1 $npars ]
 set ginp2 [list "Parameter_1 Step " "float" $gs 0 0 ]
 set ginp3 [list "Parameter_2 number to use this step  \n or 0 to remove links\n" "float"  $gp 0 $npars ]
 set ginp4 [list "Select set numbers (max 6 sets) or 0 for all" $gss 0 ]
 set ggin [list $ginp1 $ginp2 $ginp3 $ginp4]
 lappend gset $ggin
 set infrm $gset
 inframe
 if { $inmsg == "OK" } {
 set cmdout "g  $r1 $r2 $r3 $r4"
 sendcmd
 }
}
##################   epar - V parameter menu command edits parameter ########
proc epar { } {
global cmdout infrm inmsg r1 r2 r3 npars
 set enp 1
 set epv 1
 set eps 1
 set eset [list "Set Parameter" "Give starting value and step for chosen parameter"]
 set einp1 [list "Parameter number" "float" $enp 1 $npars ]
 set einp2 [list "Parameter value " "float" $epv 1 0 ]
 set einp3 [list "Step" "float"  $eps 1 0 ]
 set eein [list $einp1 $einp2 $einp3 ]
 lappend eset $eein
 set infrm $eset
 inframe
 if { $inmsg == "OK" } {
 set cmdout "v  $r1 $r2 $r3 "
 sendcmd
 }
}
##################   icmd - I parameter menu command copies par sets ########
proc icmd { } {
global cmdout infrm inmsg r1 r2 r3 r4 npars
 set ii 1
 set igs 1
 set igp 2
 set smax 20
 set iset [list "Image copy of st parameters" "Copies parameters from set_1 to set_2" ]
 set iinp1 [list "Copy Parameters from set" "float" $igs 1 $smax ]
 set iinp2 [list "To parameters for set " "float" $igp 1 $smax ]
 set iiin [list $iinp1 $iinp2 ]
 lappend iset $iiin
 set infrm $iset
 inframe
 if { $inmsg == "OK" } {
 set cmdout "i  $r1 $r2 "
 sendcmd
 }
}

#################### Initialisation of PGPLOT_DIR and .fcl file
#############################################################################
proc iniin { } {
# get environment PGPLOT_DIR to $pgdir and program configuration filename into $oldfcl
global infrm inmsg r1 r2 r3 r4 plist pexe pgdir mode oldfcl env lastanc defdir
global env cfont lastf
toplevel .ini 
focus .ini
grab .ini
frame .ini.middle
listbox .ini.middle.lb -width 80 -font $cfont -selectmode single -yscrollcommand ".ini.middle.scroll set" -background white
scrollbar .ini.middle.scroll -command ".ini.middle.lb yview"
bind .ini.middle.lb <Double-1> { 
okpgm 
if { $inmsg == "OK"  } {
destroy .ini }}
bind .ini.middle.lb <Button-1> {
.ini.edit configure -state normal -command editlb 
}
pack .ini.middle.lb -side left -expand 1 -fill both
pack .ini.middle.scroll -side right -fill y
pack .ini.middle -expand 1 -fill both
button .ini.quit -text "EXIT" -command { exit }
button .ini.clear -text "Clear program entries" -command {
.ini.middle.lb delete 0 end 
set plist ""
set pexe ""
newplb
outconf
}
button .ini.edit -text "Edit" -command editlb
button .ini.add -text "Add fit program" -command { addpgm }
button .ini.ok -text "Accept" -state disabled  -command {
okpgm
if { $inmsg == "OK" } {destroy .ini } } 
####### need to check prog and pgplot...................
pack .ini.quit .ini.clear .ini.edit .ini.add .ini.ok -side left -expand 1
set pexe ""
set plist ""
set lastf ""
set defdir "** not set ** - Please select and edit"
set pgdir $defdir
set lastanc 0
if { [ catch { set aa $env(PGPLOT_DIR) } ] == 0}   {
set pgdir $env(PGPLOT_DIR) }
set oldfcl ""
inconf
newplb
tkwait window .ini
}

proc okpgm { } {
# checks at end of iniin for environment and .fcl file
global mode oldfcl inmsg plist lastanc
okdefdir
if { $inmsg != "OK" } { return }
okenv
if { $inmsg == "OK" } {
set inmsg ""
# get here with valid $pgdir
set mode [.ini.middle.lb curselection ]
if { $mode < 5 } { return }
set lastanc $mode
set mm [ expr $mode - 5 ]
set oldfcl [lindex $plist $mm ]
if { [file exists $oldfcl ] == 1 } { set inmsg "OK" 
outconf
# save option selected
} else {
dblocate " $oldfcl cannot be found " }
} }

proc okdefdir { } {
# check for valid defdir
global defdir inmsg
set inmsg ""
if { [file isdirectory $defdir ] == 0} {
dblocate " Invalid default directory $defdir "
return }
set inmsg "OK"
} 

proc okenv { } {
# check for valid PGPLOT_DIR
global pgdir inmsg env pform
set inmsg ""
set grw "/grwnd.exe"
if { $pform == "unix" } {
set grw "/pgxwin_server"
}

if {[ file exists $pgdir$grw] == 0 } {
dblocate "Invalid directory for PGPLOT_DIR  $pgdir$grw not found"
return
}
set env(PGPLOT_DIR) $pgdir
set inmsg "OK"
}

proc getpg { } {
# sets environment and stores it
global inmsg infrm pgdir r1 pform
set grw "/grwnd.exe"
if { $pform == "unix" } {
set grw "/pgxwin_server"
}
set naminp "Clickfit configure PGplot environment"
set intxt "This sets up the environment variable PGPLOT_DIR"
set l1 [list "Give PGPLOT library directory \n containing $grw, \
pstn.exe, grfont6.dat etc." "filer" $pgdir ]
set ininp [list $l1 ]
set infrm [list $naminp $intxt $ininp ]
inframe
if { $inmsg == "Dismiss" } {return}
if { $inmsg != "OK" } {
dblocate $inmsg
return }
set pgdir $r1
okenv
newplb
outconf
}
proc getdir { } {
# gets default directory - if changed deletes program list
global inmsg infrm pgdir r1 defdir pexe plist lastanc
set olddefdir $defdir
set naminp "Clickfit cset default program directory"
set intxt "This sets a default directory where fitting programs are located"
set l1 [list "Give default directory containing fitting programs, \n \
control files (*.fcl), help files etc." "filep" $defdir ]
set ininp [list $l1 ]
set infrm [list $naminp $intxt $ininp ]
inframe
if { $inmsg == "Dismiss" } {return}
if { $inmsg != "OK" } {
dblocate $inmsg
return }
set defdir $r1
if { $defdir != $olddefdir  } {
# clear list and current anchor
set pexe ""
set plist ""
set lastanc 0
.ini.ok configure -state disabled 
}
newplb
outconf
}

proc outconf { } {
# stores current PGPLOT_DIR and program list + control files
global pgdir pexe plist conffile lastanc defdir
set ind 0
set ff [open $conffile w ]
puts $ff $pgdir
puts $ff $lastanc
puts $ff $defdir
set iind [llength $pexe]
if { $iind > 0 } {
set ind 0
while { $ind < $iind} {
set pex [lindex $pexe $ind ]
set pcl [lindex $plist $ind ]
puts $ff "$pex|$pcl"
incr ind 
}
}
close $ff
}

proc inconf { } {
# retrieves current PGPLOT_DIR and program list + control files
global pgdir pexe plist conffile pgfdir mode lastf lastanc defdir
set pexe ""
set plist ""
set mode 0
set lastanc 0
set aa [file exists $conffile ]
if { $aa == 1 } {
set ff [open $conffile r]
if { [ gets $ff pgfdir ] > 0 } { set pgdir $pgfdir }
if { [ gets $ff intmp ] > 0 } { set lastanc $intmp }
if { [ gets $ff intmp ] > 0 } { set defdir $intmp }
while { [gets $ff line ] >= 0 } {
set bb [split $line "|" ]
set exenam [lindex $bb 0]
set cfil [lindex $bb 1]
lappend pexe $exenam
lappend plist $cfil
set lastf $cfil
}
close $ff
}
newplb
}

proc editlb { } {
# edit mode for list box - PGPLOT_DIR or program list
global mode
set mode [.ini.middle.lb curselection ]
if { $mode == 0 } { getpg }
if { $mode == 1 } {getdir }
if { $mode > 4 } { cfig } 
}

proc cfig { } {
# edit program config files
global infrm inmsg pexe plist r1 r2 plines mode lastf defdir exenam lastanc
set ilin 0
set ilin [ .ini.middle.lb curselection ] 
set alin $ilin
if { $mode != 0 } {
incr ilin -5
set lastf [lindex $plist $ilin ] }
set naminp "Clickfit configure fit control file names"
set intxt "This reselects program details from the following file"
#dblocate "$ilin  lastinput $lastf"
set l1 [list "Give configuration filename in default directory ???.fcl or \n \
 full name of configuration file e.g. C:/--/????.fcl" "filed" $lastf ]
set ininp [list $l1 ]
set infrm [list $naminp $intxt $ininp ]
inframe
if { $inmsg == "Dismiss" } { return }
# get program name from config file
set exenam ""
set cfil $r1
set fil [open $r1 r ]
while { [ gets $fil  line ] >=0 } {
set bb [split $line | ]
set tp [lindex $bb 0]
if { $tp == "prog" } {
set exenam [lindex $bb 1]
}}
close $fil
if { $exenam == "" } return
fullexe
if { $exenam == "" } return
set lastf $cfil
set exe [file tail $exenam ]
# add prog to list (add command )
set ilin $mode
set ind [ incr ilin -5]
# replace in list
set tmp [lreplace $pexe $ind $ind $exe ]
set pexe $tmp
set tmp [lreplace $plist $ind $ind $cfil ]
set plist $tmp
 
# Now rewrite out the configuration file
outconf
# Update listbox
set lastanc $alin
newplb
}


proc addpgm { } {
# adds a new program configuration file
global infrm inmsg pexe plist r1 r2 plines mode lastf defdir exenam
set naminp "Clickfit configure fit control file names"
set intxt "This reselects program details from the following file"
set l1 [list "Give configuration filename in default directory ???.fcl or \n \
 full name of configuration file e.g. C:/--/????.fcl" "filed" $lastf]
set ininp [list $l1 ]
set infrm [list $naminp $intxt $ininp ]
inframe
# if file is not found then return is Dismiss
if { $inmsg == "Dismiss" } {return}
# get program name from config file
set cfil $r1
set exenam ""
if { [file dirname $cfil ] == "." } { set cfil $defdir/$cfil }
set fil [open $cfil r ]
while {[ gets $fil  line ] >=0 } {
set bb [split $line | ]
set tp [lindex $bb 0]
if { $tp == "prog" } {
set exenam [lindex $bb 1]
fullexe
} }
if {  $exenam  == "" } { 
close $fil
return
}

set lastf $cfil
set exe [file tail $exenam ]
# add prog to list (add command)
lappend pexe $exe
lappend plist $cfil  
close $fil
outconf
newplb
}

proc fullexe { } {
global pform exenam defdir
#test name for .exe and expand to full path
set suff ".exe"
set sufound [string first ".exe" $exenam]
if { $pform == "unix" } {
set suff ""
if { $sufound > 0} {
incr sufound -1
# remove .exe for unix
set exenam [string range $exenam 0 $sufound ]
} }
if { $sufound < 0 } {
set exenam $exenam$suff } 
# if directory not in name use default
if { [file dirname $exenam ] == "." } { set exenam $defdir/$exenam }
if { ( [file executable $exenam ] == 0 ) } {
set errs "Executable program $exenam not found"
dblocate $errs
set exenam ""
}
}


proc newplb  { } {
# updates program info listbox
global pgdir pexe plist defdir lastanc
.ini.middle.lb delete 0 end 
set pgline0 "  Current PGPLOT_DIR is $pgdir "
set pgline1 "  Current default program directory is $defdir "
set ttl "  Program              Configuration file"
set blanl "                    "
.ini.middle.lb insert end $pgline0
.ini.middle.lb insert end $pgline1
.ini.middle.lb insert end $blanl
.ini.middle.lb insert end $ttl
.ini.middle.lb insert end $blanl
# put in current pgdir as well
set ind 0
foreach in $pexe {
set cfil [lindex $plist $ind]
set exe $in
set blen [string length $blanl] 
set lexe [string length $exe ]
#blocate " $lexe $blen  in cfig"
set bblen [incr  blen -$lexe ]
set blan [string range "                     " 0 $bblen]
set plines "  $exe$blan$cfil"
.ini.middle.lb insert end $plines
incr ind
}
if { $lastanc >= 5 } {
.ini.middle.lb selection set $lastanc
.ini.ok configure -state normal }
}



###################  End of initialisation window routines

###################  viewsets shows current set info
  
proc viewsets {} {
global setlis infrm
set sw "Current set information"
set jj 0
set st ""
foreach ins $setlis {
incr jj
set ss "Set $jj : $ins \n"
set st "$st $ss"
  }
  set infrm [list $sw $st]
  inframe
  }

########                   LAYOUT main window




frame .mb -relief raised -borderwidth 2
set cfont  "-adobe-courier-medium-r-normal--16-140-*-*-*-*-*-*-*"

#menubutton .mb.readin -text "Read" -menu .mb.readin.menu 

menubutton .mb.file -text "File" -menu .mb.file.menu
menu .mb.file.menu -tearoff false
.mb.file.menu add command -label "Save parameters" -command { 
set cmdout "S"
sendcmd
}
.mb.file.menu add command -label "Add fit to list file" -command { 
set cmdout "L"
sendcmd
}
.mb.file.menu add command -label "Add full fit listing to list file" -command { 
set cmdout "L F"
sendcmd
}

.mb.file.menu add command -label "Read in" -command {
set infrm $readinfo
inframe
if {$inmsg == "OK" } {
set cmdout "R $r1"
sendcmd
}}
.mb.file.menu add command -label "Exit" -command { 
set cmdout E
sendcmd
exit }

menubutton .mb.par -text "Parameters" -menu .mb.par.menu
menu .mb.par.menu -tearoff false
.mb.par.menu add command -label "Edit parameter" -command { epar }
.mb.par.menu add command -label "Link steps" -command { gcmd }
.mb.par.menu add command -label "Copy parameter set" -command { icmd }


menubutton .mb.view -text "View" -menu .mb.view.menu
menu .mb.view.menu -tearoff false
.mb.view.menu add command -label "View log" -command { viewlog }
.mb.view.menu add command -label "View Sets" -command { viewsets }

menubutton .mb.graphics -text "Graphics" -menu .mb.graphics.menu -state disabled
menu .mb.graphics.menu -tearoff false
.mb.graphics.menu add command -label "Set scales" -command { scales } 
.mb.graphics.menu add command -label "Append PostScript plot" -command { curplo }
.mb.graphics.menu add command -label "Cursor" -command { curpro}
.mb.graphics.menu add command -label "Title" -command { addttl}
.mb.graphics.menu add command -label "File fit for later plotting" -command { wffile } 
.mb.graphics.menu add command -label "Turn off plotting of error bars" -command { 
set cmdout "B 0"
sendcmd
} 
.mb.graphics.menu add command -label "Show x errors" -command { 
set cmdout "B X"
sendcmd
} 
.mb.graphics.menu add command -label "Show y error bars" -command { set cmdout "B Y"
sendcmd
} 
.mb.graphics.menu add command -label "Show x and y error bars" -command { set cmdout "B X Y"
sendcmd
} 


### memo functions
menubutton .mb.memo -text "Memo" -menu .mb.memo.menu
menu .mb.memo.menu -tearoff false

menubutton .mb.fit -text "Fitting" -menu .mb.fit.menu
menu .mb.fit.menu -tearoff false
.mb.fit.menu add command -label "Limit X Ranges" -command {only}
.mb.fit.menu add command -label "Step size" -command {steps}

menubutton .mb.extra -text "Extras" -menu .mb.extra.menu
menu .mb.extra.menu  -tearoff false
.mb.extra.menu add command -label "Special function" -command { specmd }
.mb.extra.menu add command -label "Command" -command { mancmd }
.mb.extra.menu add command -label "Debug" -command { debpro}

menubutton .mb.help -text "Help" -menu .mb.help.menu
menu .mb.help.menu  -tearoff false
.mb.help.menu add command -label "About" -command { 
set infrm $hinfo
inframe
if { $inmsg == "OK" } {
  if { [file dirname $r1 ] == "."  } {set r1 $defdir/$r1 }
  if {  [file  exists $r1]     } {
    set vufil $r1
    viewfile
}}}
# find program command file name and pg info then configure prelude
# then program
#main window... this ommand varies with tk version - dummy at present
#wm state  . withdrawn
wm iconify .
#wm state . normal
pack .mb.file .mb.file .mb.par .mb.fit .mb.graphics .mb.view .mb.extra .mb.memo -side left
pack .mb.help -side right
pack .mb -side top -fill x
frame .main
####### comment line
label  .main.tt -text "this is a dummy message"
pack .main.tt -side top -fill x
####### parameter list box
frame .main.middle
label .main.middle.setlabel -text "(set title)"
listbox .main.middle.lb -width 68 -font $cfont -selectmode single -yscrollcommand ".main.middle.scroll set" -background white
scrollbar .main.middle.scroll -command ".main.middle.lb yview"
bind .main.middle.lb <Double-1> { vcmd }
bind .main.middle.lb <Button-3> { ggcmd } 
################################### M bits  variants start
frame .main.middle.setbuts
button .main.middle.setbuts.postfit -state disabled -text "Post-fit options" -command {specmd}
button .main.middle.setbuts.fileit -state disabled -text "File fit summary" -command { wffile }
label .main.middle.setbuts.lab -text "Select parameter set for display"
entry .main.middle.setbuts.desc  -textvariable curset
bind .main.middle.setbuts.desc <Return> { psetsho }
button .main.middle.setbuts.shall  -text "Show all parameters" -command {
set cmdout "A"
sendcmd
set vufil "$pnam.apr"
set atend 1
viewfile
}
button .main.middle.setbuts.clear  -text "Clear all data" -command {
set cmdout "R"
sendcmd
.main.middle.setlabel configure -text "(title of set)"
set setlis ""
set curset 1
set inset 0
###### should grey out fitting buttons
}
pack  .main.middle.setbuts.clear  .main.middle.setbuts.shall .main.middle.setbuts.lab .main.middle.setbuts.desc \
.main.middle.setbuts.postfit .main.middle.setbuts.fileit -side left -ipadx 20 -fill x  
pack .main.middle.setbuts -side bottom
pack .main.middle.setlabel -side top -fill x
###################### end of m bits    variant ends
pack .main.middle.lb -side left -expand 1 -fill both
pack .main.middle.scroll -side right -fill y
pack .main.middle -expand 1 -fill both
pack .main -expand 1 -fill both
frame .cmd
frame .cmd.b
#frame .cmd.t
button .cmd.b.rstart -text "Restart" -state disabled 

button .cmd.b.ex -text "EXIT" -command {
set cmdout "E"
sendcmd}
button .cmd.b.sav -text "SAVE" -command {
set cmdout "S"
sendcmd}
button .cmd.b.read -text "Read data" -command {
set infrm $readinfo
inframe
if {$inmsg == "OK" } {
set cmdout "R $retinp"
sendcmd
}}
button .cmd.b.disp -text "Display data" -state disabled -command {
set cmdout "D"
sendcmd
}
button .cmd.b.try -text "Trial Fit" -state disabled -command {
set cmdout "F"
sendcmd
}
button .cmd.b.fits -text "Fit iterations" -state disabled -command { fcmd }
entry .cmd.b.do -text "fiton" -state disabled -textvariable nfit  
bind .cmd.b.do <Return> {  fcmd }
button .cmd.b.inter -text "STOP fit" -state disabled -command { stopfit }
pack .cmd.b.ex .cmd.b.sav .cmd.b.rstart .cmd.b.read .cmd.b.disp  -side left -ipadx 10
pack .cmd.b.inter .cmd.b.do  .cmd.b.fits .cmd.b.try -side right -ipadx 10
pack .cmd.b -side left -fill both
pack .cmd -side bottom -fill both
#################################################################################
####   start of main routine                                                 ####
#################################################################################


#set vdate "12-Apr-2011"
#set vdate "17-Aug-2011"
set vdate "16-Mar-2013"
set debug 0
set cursor 0
set calc_timeout 5000
wm iconify .
set home_env APPDATA
set pform $tcl_platform(platform)
if { $pform == "unix" } {
set home_env HOME 
}
set home_dir $env($home_env)
set cfdir "$home_dir/Clickfit"
set cff [file isdirectory $cfdir ]
if { $cff == 0 } {set bb [file mkdir $cfdir ] } 
set conffile  "$cfdir/ffm.cnf"

# get PGPLOT_DIR setup ($pgdir) and name of current control file ($oldfcl)
#
# config file has........
# pgdir
# last used fcl line (+1) (here 5 or 6)
# default directory
# program1exe|program1_fcl
# program2exe|program2_fcl
#
iniin
iniget
### set up and store memos these are read in iniget, hence this position
.mb.memo.menu add command -label "m1:  $m1" -command {mmemo $m1} 
.mb.memo.menu add command -label "m2:  $m2" -command {mmemo $m2} 
.mb.memo.menu add command -label "m3:  $m3" -command {mmemo $m3} 
.mb.memo.menu add command -label "m4:  $m4" -command {mmemo $m4} 
.mb.memo.menu add command -label "Set memo" -command {setmemo}
if { $frsta == 1 } {
.cmd.b.rstart configure -state normal -command {
set cmdout "Q"
sendcmd
set infrm $preinfo
inframe
#ignore ok or dismiss to keep sequence right...
set cmdout "Prelude: $retinp "
sendcmd
set cmdout "Z"
sendcmd
# more or less dummy command to fitfun to cause write-out parameters...
updatinfo  
} }

# now obtain prelude info if there are any expected from control file
set retinp " "
if { $precall > 0 } {
set infrm $preinfo
inframe
if { $inmsg != "OK" } {
dblocate "problem starting prelude"
exit }}
#program started in iniseq..
iniseq
# send line of info to waiting program for prelude info
set cmdout "Prelude: $retinp "
sendcmd
set cmdout "Z"
sendcmd
# more or less dummy command to fitfun to write out parameters...
wm title . $title1
wm deiconify .
# Trap close GUI window button - emit terminate command to fitfun program 
wm protocol . WM_DELETE_WINDOW {
set cmdout "E"
sendcmd
exit } 
updatinfo  
#:EOF
